CfnCluster L1 construct
The AWS::EMR::Cluster resource specifies an Amazon EMR cluster.
This cluster is a collection of Amazon EC2 instances that run open source big data frameworks and applications to process and analyze vast amounts of data. For more information, see the Amazon EMR Management Guide .
Amazon EMR now supports launching task instance groups and task instance fleets as part of the AWS::EMR::Cluster resource. This can be done by using the JobFlowInstancesConfig property type's TaskInstanceGroups and TaskInstanceFleets subproperties. Using these subproperties reduces delays in provisioning task nodes compared to specifying task nodes with the AWS::EMR::InstanceGroupConfig and AWS::EMR::InstanceFleetConfig resources. Please refer to the examples at the bottom of this page to learn how to use these subproperties.
Example
// The generated example for this type would exceed 500 lines,
// and has been elided for readability.
// Install: dotnet add package Amazon.CDK.Lib
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
Initializer
new CfnCluster(scope: Construct, id: string, props: CfnClusterProps)
CfnCluster(scope: Construct, id: str, props: CfnClusterProps)
new CfnCluster(Construct scope, String id, CfnClusterProps props)
new CfnCluster(Construct scope, string id, CfnClusterProps props)
NewCfnCluster(Scope Construct, Id *string, Props CfnClusterProps)
Construct Props
additionalInfooptionalanyadditional_infooptionalAnyadditionalInfooptionalObjectAdditionalInfooptionalobjectAdditionalInfooptionalinterface{}#applicationsoptionalIResolvable | IResolvable | CfnCluster.ApplicationProperty[]applicationsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ApplicationProperty]]]applicationsoptionalIResolvableApplicationsoptionalIResolvableApplicationsoptionalinterface{}#autoScalingRoleoptionalstringauto_scaling_roleoptionalstrautoScalingRoleoptionalStringAutoScalingRoleoptionalstringAutoScalingRoleoptional*string#The default role is EMR_AutoScaling_DefaultRole . The IAM role provides permissions that the automatic scaling feature requires to launch and terminate Amazon EC2 instances in an instance group.
autoTerminationPolicyoptionalIResolvable | CfnCluster.AutoTerminationPolicyPropertyauto_termination_policyoptionaltyping.Union[IResolvable, AutoTerminationPolicyProperty]autoTerminationPolicyoptionalIResolvableAutoTerminationPolicyoptionalIResolvableAutoTerminationPolicyoptionalinterface{}#notes
An auto-termination policy defines the amount of idle time in seconds after which a cluster automatically terminates. For alternative cluster termination options, see Control cluster termination .
bootstrapActionsoptionalIResolvable | IResolvable | CfnCluster.BootstrapActionConfigProperty[]bootstrap_actionsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, BootstrapActionConfigProperty]]]bootstrapActionsoptionalIResolvableBootstrapActionsoptionalIResolvableBootstrapActionsoptionalinterface{}#configurationsoptionalIResolvable | IResolvable | CfnCluster.ConfigurationProperty[]configurationsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ConfigurationProperty]]]configurationsoptionalIResolvableConfigurationsoptionalIResolvableConfigurationsoptionalinterface{}#customAmiIdoptionalstringcustom_ami_idoptionalstrcustomAmiIdoptionalStringCustomAmiIdoptionalstringCustomAmiIdoptional*string#ebsRootVolumeIopsoptionalnumberebs_root_volume_iopsoptionalint | floatebsRootVolumeIopsoptionalNumberEbsRootVolumeIopsoptionaldoubleEbsRootVolumeIopsoptional*float64#Available in Amazon EMR releases 6.15.0 and later.
ebsRootVolumeSizeoptionalnumberebs_root_volume_sizeoptionalint | floatebsRootVolumeSizeoptionalNumberEbsRootVolumeSizeoptionaldoubleEbsRootVolumeSizeoptional*float64#Available in Amazon EMR releases 4.x and later.
ebsRootVolumeThroughputoptionalnumberebs_root_volume_throughputoptionalint | floatebsRootVolumeThroughputoptionalNumberEbsRootVolumeThroughputoptionaldoubleEbsRootVolumeThroughputoptional*float64#Available in Amazon EMR releases 6.15.0 and later.
instancesIResolvable | CfnCluster.JobFlowInstancesConfigPropertyinstancestyping.Union[IResolvable, JobFlowInstancesConfigProperty]instancesIResolvableInstancesIResolvableInstancesinterface{}required#An IAM role for an Amazon EMR cluster. The Amazon EC2 instances of the cluster assume this role. The default role is EMR_EC2_DefaultRole . In order to use the default role, you must have already created it using the AWS CLI or console.
kerberosAttributesoptionalIResolvable | CfnCluster.KerberosAttributesPropertykerberos_attributesoptionaltyping.Union[IResolvable, KerberosAttributesProperty]kerberosAttributesoptionalIResolvableKerberosAttributesoptionalIResolvableKerberosAttributesoptionalinterface{}#For more information see Use Kerberos Authentication in the Amazon EMR Management Guide .
logEncryptionKmsKeyIdoptionalstringlog_encryption_kms_key_idoptionalstrlogEncryptionKmsKeyIdoptionalStringLogEncryptionKmsKeyIdoptionalstringLogEncryptionKmsKeyIdoptional*string#This attribute is only available with Amazon EMR 5.30.0 and later, excluding Amazon EMR 6.0.0.
logUrioptionalstringlog_urioptionalstrlogUrioptionalStringLogUrioptionalstringLogUrioptional*string#managedScalingPolicyoptionalIResolvable | CfnCluster.ManagedScalingPolicyPropertymanaged_scaling_policyoptionaltyping.Union[IResolvable, ManagedScalingPolicyProperty]managedScalingPolicyoptionalIResolvableManagedScalingPolicyoptionalIResolvableManagedScalingPolicyoptionalinterface{}#notes
The managed scaling policy defines the limits for resources, such as Amazon EC2 instances that can be added or terminated from a cluster. The policy only applies to the core and task nodes. The master node cannot be scaled after initial configuration.
This parameter can't contain the characters <, >, $, |, or ` (backtick).
osReleaseLabeloptionalstringos_release_labeloptionalstrosReleaseLabeloptionalStringOsReleaseLabeloptionalstringOsReleaseLabeloptional*string#If no Amazon Linux release was specified, the default Amazon Linux release is shown in the response.
placementGroupConfigsoptionalIResolvable | IResolvable | CfnCluster.PlacementGroupConfigProperty[]placement_group_configsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, PlacementGroupConfigProperty]]]placementGroupConfigsoptionalIResolvablePlacementGroupConfigsoptionalIResolvablePlacementGroupConfigsoptionalinterface{}#releaseLabeloptionalstringrelease_labeloptionalstrreleaseLabeloptionalStringReleaseLabeloptionalstringReleaseLabeloptional*string#notes
Release labels are in the form emr-x.x.x , where x.x.x is an Amazon EMR release version such as emr-5.14.0 . For more information about Amazon EMR release versions and included application versions and features, see . The release label applies only to Amazon EMR releases version 4.0 and later. Earlier versions use AmiVersion .
scaleDownBehavioroptionalstringscale_down_behavioroptionalstrscaleDownBehavioroptionalStringScaleDownBehavioroptionalstringScaleDownBehavioroptional*string#notes
TERMINATE_AT_INSTANCE_HOUR indicates that Amazon EMR terminates nodes at the instance-hour boundary, regardless of when the request to terminate the instance was submitted. This option is only available with Amazon EMR 5.1.0 and later and is the default for clusters created using that version. TERMINATE_AT_TASK_COMPLETION indicates that Amazon EMR adds nodes to a deny list and drains tasks from nodes before terminating the Amazon EC2 instances, regardless of the instance-hour boundary. With either behavior, Amazon EMR removes the least active nodes first and blocks instance termination if it could lead to HDFS corruption. TERMINATE_AT_TASK_COMPLETION is available only in Amazon EMR releases 4.1.0 and later, and is the default for versions of Amazon EMR earlier than 5.1.0.
securityConfigurationoptionalstringsecurity_configurationoptionalstrsecurityConfigurationoptionalStringSecurityConfigurationoptionalstringSecurityConfigurationoptional*string#stepConcurrencyLeveloptionalnumberstep_concurrency_leveloptionalint | floatstepConcurrencyLeveloptionalNumberStepConcurrencyLeveloptionaldoubleStepConcurrencyLeveloptional*float64#The default value is 1 . The maximum value is 256 .
stepsoptionalIResolvable | IResolvable | CfnCluster.StepConfigProperty[]stepsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, StepConfigProperty]]]stepsoptionalIResolvableStepsoptionalIResolvableStepsoptionalinterface{}#tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#visibleToAllUsersoptionalboolean | IResolvablevisible_to_all_usersoptionaltyping.Union[bool, IResolvable]visibleToAllUsersoptionalBooleanVisibleToAllUsersoptionalboolVisibleToAllUsersoptionalinterface{}#notes
If this value is set to true , all IAM users of that AWS account can view and manage the cluster if they have the proper policy permissions set. If this value is false , only the IAM user that created the cluster can view and manage it. This value can be changed using the SetVisibleToAllUsers action.
When you create clusters directly through the EMR console or API, this value is set to
trueby default. However, forAWS::EMR::Clusterresources in CloudFormation, the default isfalse.
Properties
additionalInfoanyadditional_infoAnyadditionalInfoObjectAdditionalInfoobjectAdditionalInfointerface{}#applicationsmay be undefinedIResolvable | IResolvable | CfnCluster.ApplicationProperty[]applicationsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ApplicationProperty]]]applicationsmay be undefinedIResolvableApplicationsmay be undefinedIResolvableApplicationsmay be undefinedinterface{}#attrMasterPublicDnsstringattr_master_public_dnsstrattrMasterPublicDnsStringAttrMasterPublicDnsstringAttrMasterPublicDns*string#autoScalingRolemay be undefinedstringauto_scaling_rolemay be undefinedstrautoScalingRolemay be undefinedStringAutoScalingRolemay be undefinedstringAutoScalingRolemay be undefined*string#autoTerminationPolicymay be undefinedIResolvable | CfnCluster.AutoTerminationPolicyPropertyauto_termination_policymay be undefinedtyping.Union[IResolvable, AutoTerminationPolicyProperty]autoTerminationPolicymay be undefinedIResolvableAutoTerminationPolicymay be undefinedIResolvableAutoTerminationPolicymay be undefinedinterface{}#bootstrapActionsmay be undefinedIResolvable | IResolvable | CfnCluster.BootstrapActionConfigProperty[]bootstrap_actionsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, BootstrapActionConfigProperty]]]bootstrapActionsmay be undefinedIResolvableBootstrapActionsmay be undefinedIResolvableBootstrapActionsmay be undefinedinterface{}#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptions#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#clusterRefClusterReferencecluster_refClusterReferenceclusterRefClusterReferenceClusterRefClusterReferenceClusterRefClusterReference#configurationsmay be undefinedIResolvable | IResolvable | CfnCluster.ConfigurationProperty[]configurationsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ConfigurationProperty]]]configurationsmay be undefinedIResolvableConfigurationsmay be undefinedIResolvableConfigurationsmay be undefinedinterface{}#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#customAmiIdmay be undefinedstringcustom_ami_idmay be undefinedstrcustomAmiIdmay be undefinedStringCustomAmiIdmay be undefinedstringCustomAmiIdmay be undefined*string#ebsRootVolumeIopsmay be undefinednumberebs_root_volume_iopsmay be undefinedint | floatebsRootVolumeIopsmay be undefinedNumberEbsRootVolumeIopsmay be undefineddoubleEbsRootVolumeIopsmay be undefined*float64#ebsRootVolumeSizemay be undefinednumberebs_root_volume_sizemay be undefinedint | floatebsRootVolumeSizemay be undefinedNumberEbsRootVolumeSizemay be undefineddoubleEbsRootVolumeSizemay be undefined*float64#ebsRootVolumeThroughputmay be undefinednumberebs_root_volume_throughputmay be undefinedint | floatebsRootVolumeThroughputmay be undefinedNumberEbsRootVolumeThroughputmay be undefineddoubleEbsRootVolumeThroughputmay be undefined*float64#instancesIResolvable | CfnCluster.JobFlowInstancesConfigPropertyinstancestyping.Union[IResolvable, JobFlowInstancesConfigProperty]instancesIResolvableInstancesIResolvableInstancesinterface{}#kerberosAttributesmay be undefinedIResolvable | CfnCluster.KerberosAttributesPropertykerberos_attributesmay be undefinedtyping.Union[IResolvable, KerberosAttributesProperty]kerberosAttributesmay be undefinedIResolvableKerberosAttributesmay be undefinedIResolvableKerberosAttributesmay be undefinedinterface{}#logEncryptionKmsKeyIdmay be undefinedstringlog_encryption_kms_key_idmay be undefinedstrlogEncryptionKmsKeyIdmay be undefinedStringLogEncryptionKmsKeyIdmay be undefinedstringLogEncryptionKmsKeyIdmay be undefined*string#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
logUrimay be undefinedstringlog_urimay be undefinedstrlogUrimay be undefinedStringLogUrimay be undefinedstringLogUrimay be undefined*string#managedScalingPolicymay be undefinedIResolvable | CfnCluster.ManagedScalingPolicyPropertymanaged_scaling_policymay be undefinedtyping.Union[IResolvable, ManagedScalingPolicyProperty]managedScalingPolicymay be undefinedIResolvableManagedScalingPolicymay be undefinedIResolvableManagedScalingPolicymay be undefinedinterface{}#osReleaseLabelmay be undefinedstringos_release_labelmay be undefinedstrosReleaseLabelmay be undefinedStringOsReleaseLabelmay be undefinedstringOsReleaseLabelmay be undefined*string#placementGroupConfigsmay be undefinedIResolvable | IResolvable | CfnCluster.PlacementGroupConfigProperty[]placement_group_configsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, PlacementGroupConfigProperty]]]placementGroupConfigsmay be undefinedIResolvablePlacementGroupConfigsmay be undefinedIResolvablePlacementGroupConfigsmay be undefinedinterface{}#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
releaseLabelmay be undefinedstringrelease_labelmay be undefinedstrreleaseLabelmay be undefinedStringReleaseLabelmay be undefinedstringReleaseLabelmay be undefined*string#scaleDownBehaviormay be undefinedstringscale_down_behaviormay be undefinedstrscaleDownBehaviormay be undefinedStringScaleDownBehaviormay be undefinedstringScaleDownBehaviormay be undefined*string#securityConfigurationmay be undefinedstringsecurity_configurationmay be undefinedstrsecurityConfigurationmay be undefinedStringSecurityConfigurationmay be undefinedstringSecurityConfigurationmay be undefined*string#CfnElements must be defined within a stack scope (directly or indirectly).
stepConcurrencyLevelmay be undefinednumberstep_concurrency_levelmay be undefinedint | floatstepConcurrencyLevelmay be undefinedNumberStepConcurrencyLevelmay be undefineddoubleStepConcurrencyLevelmay be undefined*float64#stepsmay be undefinedIResolvable | IResolvable | CfnCluster.StepConfigProperty[]stepsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, StepConfigProperty]]]stepsmay be undefinedIResolvableStepsmay be undefinedIResolvableStepsmay be undefinedinterface{}#tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag#visibleToAllUsersmay be undefinedboolean | IResolvablevisible_to_all_usersmay be undefinedtyping.Union[bool, IResolvable]visibleToAllUsersmay be undefinedBooleanVisibleToAllUsersmay be undefinedboolVisibleToAllUsersmay be undefinedinterface{}#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForCluster(resource: IClusterRef): string@staticmethod def arn_for_cluster(resource: IClusterRef) -> strpublic static String arnForCluster(IClusterRef resource)public static string ArnForCluster(IClusterRef resource)func ArnForCluster(Resource IClusterRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#fromClusterId(scope: Construct, id: string, clusterId: string): IClusterRef@staticmethod def from_cluster_id(scope: Construct, id: str, cluster_id: str) -> IClusterRefpublic static IClusterRef fromClusterId(Construct scope, String id, String clusterId)public static IClusterRef FromClusterId(Construct scope, string id, string clusterId)func FromClusterId(Scope Construct, Id *string, ClusterId *string) IClusterRefstatic#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnCluster(x: any): boolean@staticmethod def is_cfn_cluster(x: Any) -> boolpublic static Boolean isCfnCluster(Object x)public static bool IsCfnCluster(object x)func IsCfnCluster(X interface{}) *boolstatic#isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.